require "securerandom"

module Urg
class SecureData
  def self.encrypt(plaintext)
    cipher.encrypt
    key = cipher.random_key
    iv = cipher.random_iv
    cyphertext = cipher.update(plaintext) + cipher.final

    {
      cyphertext: Base64.strict_encode64(cyphertext),
      key: Base64.strict_encode64(key),
      iv: Base64.strict_encode64(iv)
    }
  end

  def self.decrypt(cyphertext, iv:, key:)
    cipher.decrypt
    cipher.key = Base64.strict_decode64(key)
    cipher.iv = Base64.strict_decode64(iv)
    cipher.update(Base64.strict_decode64(cyphertext)) + cipher.final
  end

  private

  def self.cipher
    @cipher ||= OpenSSL::Cipher::AES.new(256, :CBC)
  end
end
end
