require "base64"
require "zlib"
require "openssl"
require "open-uri"

require_relative "./one_time_secret"
require_relative "./secure_data"

module Urg
  DEFAULT_PUBLIC_KEY_URI = "https://urg-public-keys.s3-us-west-2.amazonaws.com/urg-exfil.pub"

  def self.export(object)
    string = Base64.encode64(Zlib::Deflate.deflate(Marshal.dump(object)))

    encryption = SecureData.encrypt(string)

    ots_passphrase = SecureRandom.urlsafe_base64
    ots = OneTimeSecret.new.share_secret(encryption[:cyphertext], passphrase: ots_passphrase)

    puts (("*" * 25) + "\n") * 1
    puts "Exported. Data will self-destruct in 10 minutes OR after first use, whichever comes first."
    puts "Import data remotely via: Urg.import(ots_key: \"#{ots['secret_key']}\", ots_passphrase: \"#{ots_passphrase}\", decryption_key: \"#{encryption[:key]}\", decryption_iv: \"#{encryption[:iv]}\")"
    puts (("*" * 25) + "\n") * 1
  end

  def self.import(ots_key:, ots_passphrase:, decryption_key:, decryption_iv:)
    ots = OneTimeSecret.new.fetch_secret(ots_key, passphrase: ots_passphrase)
    plaintext = SecureData.decrypt(ots["value"], iv: decryption_iv, key: decryption_key)
    Marshal.load(Zlib::Inflate.inflate(Base64.decode64(plaintext)))
  end

  def self.exfil(object, key: DEFAULT_PUBLIC_KEY_URI)
    if key
      public_key_uri = URI.parse(key)
      public_key = OpenSSL::PKey::RSA.new(public_key_uri.read)
      str = Base64.encode64(public_key.public_encrypt(Base64.encode64(Zlib::Deflate.deflate(Marshal.dump(object))), OpenSSL::PKey::RSA::PKCS1_OAEP_PADDING))
      key_arg = key == DEFAULT_PUBLIC_KEY_URI ? "\"#{key}\"" : "YOUR_PRIVATE_KEY_LOCATION"
    else
      str = Base64.encode64(Zlib::Deflate.deflate(Marshal.dump(object)))
      key_arg = "nil"
    end

    puts "🚀"*20
    puts "Urg.infil(\"#{str}\", key: #{key_arg})"
    puts "🚀"*20
  end

  def self.infil(str, key:nil)
    unless key
      return Marshal.load(Zlib::Inflate.inflate(Base64.decode64(str)))
    end

    if key == DEFAULT_PUBLIC_KEY_URI
      private_key_content = ENV["URG_EXFIL_PRIVATE_KEY"]
    else
      private_key_content = open(key)
    end

    private_key = OpenSSL::PKey::RSA.new(private_key_content)
    Marshal.load(Zlib::Inflate.inflate(Base64.decode64(private_key.private_decrypt(Base64.decode64(str), OpenSSL::PKey::RSA::PKCS1_OAEP_PADDING))))
  end
end
